// File...: Udpsvrl.c
// Version: 1.00 (Build 1 - Linux Version)
// Date...: 30.April.2001 (kdw@ist1.de)
// (c) Klaus-D. Walter. All Rights reserved.

//              *** DISCLAIMER OF WARRENTY ***
// =======================================================
// THIS  CODE AND INFORMATION IS PROVIDED "AS IS"  WITHOUT
// A  WARRANTY OF  ANY KIND, EITHER  EXPRESSED OR  IMPLIED,
// INCLUDING  BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.

// Includes

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

// Function prototype

int  main      (int, char **);       // The one any only main function
void UdpServer (short);              // Wait for Client data...

/////////////////////////////////////////////////////////////////////////////
// main

int main (int argc, char **argv)
{
   short   nPort;

   // Check for port argument. Print usage if no port number...

   if (argc != 2) {
      printf ("\n  Server usage: UdpsvrL PortNumber.");
      printf ("\n  Example.....: UdpsvrL 5000<enter>\n\n");
      return (1);
   }
   nPort= atoi (argv[1]);
	
   // Do all the stuff a UDP server does...

   UdpServer (nPort);
   printf ("\n");
   return (1);
}

/////////////////////////////////////////////////////////////////////////////
// UdpServer

void UdpServer (short nPort)
{
   int    nRet, theSocket,
          nLen= sizeof (struct sockaddr);
   char   szBuf[256];
   struct sockaddr_in saServer, saClient;

   // Create a UDP/IP datagram socket.

   theSocket= socket (AF_INET, SOCK_DGRAM, 0);

   // ... and check for error...

   if (theSocket < 0)	{
      printf ("\n  Can t create Socket.\n");
      return;
   }

   // Fill in the address structure...

   saServer.sin_family= AF_INET;
   saServer.sin_addr.s_addr= INADDR_ANY;
   saServer.sin_port= htons (nPort);

   // Bind the name to the socket...

   nRet= bind (theSocket, &saServer, sizeof (struct sockaddr));

   // ... and check for any errors...

   if (nRet < 0) {
      printf ("\n  Error in bind function.\n");
      close (theSocket);
      return;
   }

   // Wait in a server loop ...

   while (1) {

      // Wait for data from the client...

      printf ("\n  UDP Server (Linux) Vers. 1.00 is waiting on port \"%d\"", nPort);
      printf ("\n  ============================================================");			
      memset (szBuf, 0, sizeof (szBuf));
      nRet= recvfrom (theSocket, szBuf, sizeof (szBuf), 0, &saClient, &nLen);

      // Show client addr and received data...

      printf ("\n  Data from addr %s received: %s", inet_ntoa (saClient.sin_addr), szBuf);

      // Send data back to the client...

      strcpy (szBuf, "OK from the Server.");
      printf ("\n  Send some data back to %s : %s\n", inet_ntoa (saClient.sin_addr), szBuf);
      sendto (theSocket, szBuf, strlen (szBuf), 0, &saClient, nLen);
   }
}
